/**
 * @file scene_init.cpp
 * @author Frederic MARTIN [martin-frederic@users.sourceforge.net]
 * @brief Implemente E_scene_init et E_scene_intro. Voir scenes.h pour la liste de toutes les scenes
 */

 
 
#include "scene_init.h"
#include "utils.h"



//--------------------------------------------------//
//--------------------------------------------------//
//                 **  Echec_Scene **               //
//--------------------------------------------------//
//--------------------------------------------------//

Echec_Scene::Echec_Scene()
{
	deja_charge=false;
}

Echec_Scene::~Echec_Scene()
{

}

void Echec_Scene::fin_du_chargement()
{
	SDL_Delay(100);
	// Apres un long chargement, 2 actualisations sont nécessaires pour une
	// valeur correcte de temps_ecoule dans GlobalInfos
	pGlobalInfos->actualiser();
	pGlobalInfos->actualiser();
	
	deja_charge=true;	
}

//--------------------------------------------------//
//--------------------------------------------------//
//               **  E_scene_init **                //
//--------------------------------------------------//
//--------------------------------------------------//

E_scene_init::E_scene_init()
{

}

E_scene_init::~E_scene_init()
{

}

bool E_scene_init::charger()
{
	if (deja_charge)
		return true;
	
	
	
	fin_du_chargement();
	return true;
}

void E_scene_init::decharger()
{
	if (deja_charge==false)
		return;
	

	
	deja_charge=false;
}

void E_scene_init::actualiser()
{
	if (deja_charge==false)
	{
		if ( charger()==false )
		{
			printf("Loading of 'E_scene_init' failed: exiting...\n");
			pGlobalInfos->quitter_le_jeu();
			return;
		}
	}
	//TODO: Ajouter l'initialisation ici
	
	pGlobalInfos->changer_de_scene(E_SCENE_INTRO);

	SDL_Delay(10);

}



//--------------------------------------------------//
//--------------------------------------------------//
//              **  E_scene_intro **                //
//--------------------------------------------------//
//--------------------------------------------------//

E_scene_intro::E_scene_intro()
{

}

E_scene_intro::~E_scene_intro()
{

}

bool E_scene_intro::charger()
{
	if (deja_charge)
		return true;
	
	
	
	fin_du_chargement();
	return true;
}

void E_scene_intro::decharger()
{
	if (deja_charge==false)
		return;
	

	
	deja_charge=false;
	
}

void E_scene_intro::actualiser()
{
	if (deja_charge==false)
	{
		if ( charger()==false )
		{
			printf("Loading of 'E_scene_intro' failed: exiting...\n");
			pGlobalInfos->quitter_le_jeu();
			return;
		}
	}
	// TODO : ajouter l'intro ici
	pGlobalInfos->changer_de_scene(E_SCENE_MENU_PRINCIPAL);

	SDL_Delay(10);
}

