/**
 * @file scene_menu_principal.h
 * @author Frederic MARTIN [martin-frederic@users.sourceforge.net]
 * @brief Implémente E_scene_menu_principal. Voir scenes.h pour la liste de toutes les scenes
 */


#ifndef __E_SCENE_MENU_PRINCIPAL_H__
#define __E_SCENE_MENU_PRINCIPAL_H__


#include "scenes.h"

const int NOMBRE_DE_MESSAGES_DES_CREDITS=35;


class E_scene_menu_principal: public Echec_Scene
{
	public:
		E_scene_menu_principal();
		virtual ~E_scene_menu_principal();
		virtual bool charger();
		virtual void decharger();
		virtual void actualiser();
		
		void afficher_menu_init();
		void afficher_credits_init();
		
		void prochaine_scene(int prochaine)				{scene_suivante=prochaine;}
	
	private:
		CGui un_gui;
		
		GLuint liste_des_modeles;
		
		Texture* titre;
		Texture* fontTexture;
		Texture* textureSol;
		Texture* damier;
		Texture* texture_bouton_un_joueur;
		Texture* texture_bouton_deux_joueurs;
		Texture* texture_bouton_credits;
		Texture* texture_bouton_quitter;
		Texture* texture_blender;
		Texture* texture_kate;
		Texture* texture_gimp;
		Texture* texture_tux;
		
		
		int scene_suivante;// prochaine scene après le fade_in
		
		bool fade_out; // si vrai alors on est en mode fade_out
		bool fade_in;  // si vrai alors on est en mode fade_in
		
		bool doit_afficher_credits;
		bool doit_afficher_menu;
		
		GLfloat fade_out_valeur;
		GLfloat fade_in_valeur;
		
		GLfloat angleCameraX,angleCameraZ;
		
		CGuiButtonImage bouton_un_joueur;
		CGuiButtonImage bouton_deux_joueurs;
		CGuiButtonImage bouton_credits;
		CGuiButtonImage bouton_quitter;
		
		CGuiLabel titre_info;
		CGuiLabel label_un_joueur;
		CGuiLabel label_deux_joueurs;
		CGuiLabel label_credits;
		CGuiLabel label_quitter;
		CGuiLabel numero_version;
		
		// pour les credits
		int credits_position;
		CGuiLabel* credits_labels[NOMBRE_DE_MESSAGES_DES_CREDITS];

		void afficher_echiquier();
		// les deux possibilités pour le menu principal :
		// soit on affiche le menu soit on affiche les crédits
		void afficher_menu();
		void afficher_credits();
		
};



#endif

