/**
 * @file scenes.h
 * @author Frederic MARTIN [martin-frederic@users.sourceforge.net]
 * @brief Fichier d'en tete principal pour toutes les scenes du jeu
 */


#ifndef __MF_SCENES_H__
#define __MF_SCENES_H__

#include "texture.h"
#include "gui.h"
#include "globalInfos.h"



// NE PAS OUBLIER de mettre a jour NOMBRE_DE_SCENES dans globalInfos.h lors du changement de cet enum
enum scenes_du_jeu
{
	E_SCENE_INIT,
	E_SCENE_INTRO,
	E_SCENE_MENU_PRINCIPAL,
	E_SCENE_JEU_PRINCIPAL,
};


class Echec_Scene
{
	public:
		Echec_Scene();
		virtual ~Echec_Scene();
		virtual bool charger()=0;	// fonction virtuelle pure : DOIT etre implementee par les classes derivees!
		virtual void decharger()=0; // fonction virtuelle pure : DOIT etre implementee par les classes derivees!
		virtual void actualiser()=0;// fonction virtuelle pure : DOIT etre implementee par les classes derivees!
	protected:
		bool deja_charge;
		void fin_du_chargement();
	
};



#endif
