/**
 * @name utils.cpp
 * @author Frederic MARTIN [martin-frederic@users.sourceforge.net]
 * @brief Fonctions utiles
 */


#include "utils.h"

/**************************************************************************************/
// Passe en mode 2D ()
// a utliser en conjonction avec quitter_la_2d()
void aller_en_2d()
{
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho( 0.0f, 1024.0f, 768.0f, 0.0f, 0.0f, 1.0f );
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	glDisable(GL_LIGHTING);
}


/**************************************************************************************/
// Quitte le mode 2D
// a utliser en conjonction avec aller_en_2d()
void quitter_la_2d()
{
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	glEnable(GL_LIGHTING);
}


/**************************************************************************************/
void dessiner_rectangle(int X, int Y,int largeur,int hauteur)
{
	glBegin(GL_LINE_LOOP);
		glVertex2i(X, Y);
		glVertex2i(X, Y+hauteur);
		glVertex2i(X+largeur,Y+hauteur);
		glVertex2i(X+largeur,Y);
		glVertex2i(X, Y);
	glEnd();
}

/**************************************************************************************/
void dessiner_rectangle_2(int x1, int y1,int x2,int y2)
{
	glBegin(GL_LINE_LOOP);
		glVertex2i(x1, y1);
		glVertex2i(x1, y2);
		glVertex2i(x2, y2);
		glVertex2i(x2, y1);
		glVertex2i(x1, y1);
	glEnd();
}

/**************************************************************************************/
void dessiner_rectangle_plein(int x1, int y1,int x2,int y2)
{
	glBegin(GL_QUADS);
		glVertex2i(x1, y1);
		glVertex2i(x1, y2);
		glVertex2i(x2, y2);
		glVertex2i(x2, y1);
	glEnd();
}


/**************************************************************************************/
void dessiner_image(int X, int Y,int largeur,int hauteur,Texture* image)
{
	glEnable(GL_TEXTURE_2D);
	image->utiliser();
	
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f);		glVertex2i(X, Y);
		glTexCoord2f(0.0f, 1.0f);		glVertex2i(X, Y+hauteur);
		glTexCoord2f(1.0f, 1.0f);		glVertex2i(X+largeur,Y+hauteur);
		glTexCoord2f(1.0f, 0.0f);		glVertex2i(X+largeur,Y);
	glEnd();
	
	glDisable(GL_TEXTURE_2D);
}



/**************************************************************************************/
void effaceEcran()
{
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	SDL_GL_SwapBuffers();
}


